Subject: bug#32443: 27.0.50; encode-time bug

From: Live System User <[email-masked]>
Date: Sat, 22 Sep 2018 00:37:11 -0400

Robert Pluim <[email-masked]> writes:

> Live System User <[email-masked]> writes:
>
>> Robert Pluim <[email-masked]> writes:
>
>>> None of those fail for me. Could you tell us which revision youʼre
>>> currently using? Perhaps this got fixed as a side effect of some other
>>> change, in which case I can bisect it.
>>
>>   I just tried it using:
>>
>> Repository revision: d8bef4b519624de20baa1428dd103f61dfb220fa
>>
>>    and got the same errpneous results.
>
> And thatʼs more recent than my version, so the bug is still lurking
> somewhere.
>
>>>
>>> Otherwise, since youʼre the only one who can reproduce it, could you
>>> do 'edebug-defun' on 'parse-time-string' and step through it? That
>>> might give us a better idea of what's going wrong.
>>
>>
>>   I've never used `edebug' before so I will have to get up to speed.
>
> SPC single steps. You can use 'e' to evaluate arbitrary expressions in
> the context of the function youʼre debugging. Since single stepping
> can be tedious, you can move point and use 'h' to run until you reach
> point.

  I'm still trying to discover where the bug is using edebug,

  Stepping through with edebug everything appears to go fine
  with going through all the rules and assigning all of its
  resultant values (such as "Tue' equals 2 gleen from
  `parse-time-weekdays '), until you get to the following:

        (rplaca (nthcdr (pop slots) time) new-val))))))))

  Once I execute `rplaca' -- "tike" and "new-val" are incorrect.
  
 FWIW, with thw recwnt update to parse-time.el (Git 0bec064), I now
 get

(parse-time-string "Tue, 21 Feb 2017 17:17:56 -0500")
 (nil nil nil 21 2 2017 2 -1 nil)

`Before this update, the "-1" was nil.

 I believe the "-1" means that DST is not known to be in effect.

 DST *is* in effect here.

`Thanks.
> Robert